#include "qobject.h"
#include "qevent.h"
#include <unistd.h>

QObject * QObject::m_TimerList[MAXTIMERS];

bool QObject::m_bInit = false;

void QObject::InitializeTimers()
{
  signal(SIGUSR1, timerpop);
}

void QObject::killTimer(int id)
{
  DestroyTimer(id);
}

void QObject::TimerFire()
{ 
  m_bTriggered = false; 
  QTimerEvent e;
  timerEvent(&e);
}

void QObject::timerEvent(QTimerEvent * e)
{
  cerr << "QObject::timerEvent base called\n";
}

int QObject::startTimer(int interval)
{
  CreateTimer();
  pthread_attr_t a;
  pthread_attr_init(&a);
  
  m_USecs = interval;
  m_bOneShot = false;

  pthread_create(&m_Thread, &a,runthread,this);
}

int QObject::CreateTimer()
{ 
  m_bTriggered = false;

  if(!m_bInit) {
    InitializeTimers();
    m_bInit = true;
  }
  for(int i=0; i<MAXTIMERS; i++) {
    if(m_TimerList[i] == 0) {
      m_TimerList[i] = this;
      return i;
      break;
    }
  } 
  return -1;
}	

void QObject::DestroyTimer(int timer)
{
  m_TimerList[timer] = 0;
  m_bOneShot = true;
  m_Thread = 0;
}

void * QObject::runthread(void * p)
{
  QObject * pThis = (QObject*)p;

  do {
    usleep(pThis->m_USecs * 1000);
    pThis->m_bTriggered = true;
    raise(SIGUSR1);
  } while(!pThis->m_bOneShot);

  return 0;
}

void QObject::timerpop(int sig)
{
  QObject * t;
  
  t = FindTimer();
  while(t) {
    t->TimerFire();
    t = FindTimer();
  }
}

QObject * QObject::FindTimer()
{
  for(int i=0; i<MAXTIMERS; i++) {
    if(m_TimerList[i]) {
      if(m_TimerList[i]->m_bTriggered) {
	return m_TimerList[i];
      }
    }
  }
  return 0;
}
