#ifndef QOBJECT_H
#define QOBJECT_H

#include "qobjectdefs.h"

#include "qmetaobject.h"
#include <iostream.h>
#include <signal.h>
#include <pthread.h>

#define MAXTIMERS 100


class QTimerEvent;

class QObject
{
  // timer support
 protected:
  static bool m_bInit;

  static QObject * m_TimerList[MAXTIMERS];
  bool m_bTriggered;
  bool m_bOneShot;
  pthread_t m_Thread;
  
  static QObject * FindTimer();
  void TimerFire();

  static void * runthread(void*p);

  int m_USecs;

  int CreateTimer();
  void DestroyTimer(int timerid);

 public:
  static void timerpop(int);
  void InitializeTimers();

 protected:
  QConnectionList * receivers(const char * signal) const { return 0; }

 public:

  virtual void timerEvent(QTimerEvent * e);

  int startTimer(int interval);
  void killTimer(int id);
  bool inherits(const char * c) const { }
  virtual const char * className() const { return "ClassNULL"; }
  static bool connect ( const QObject * sender, 
			const char * signal, const QObject * receiver,
			const char * member )
    { cerr << "Connecting to " << member << "\n"; return false; }
  bool connect ( const QObject * sender, const char * signal, 
		 const char * member ) const 
    { cerr << "Connecting to " << member << "\n"; return false; }
  bool disconnect ( const char * signal=0, const QObject * receiver=0, 
		    const char * member=0 ) { return false; }
  bool disconnect ( const QObject * receiver, 
		    const char * member=0 ) { return false; }

  virtual void initMetaObject() { }

  static void badSuperclassWarning(const char * className,
				   const char * superclassName) { }

  bool signalsBlocked() const { return false; }
  void blockSignals(bool b) { }
  void activate_signal(const char * signal, const char *) { }
  void activate_signal(const char * signal) { }
  void activate_signal(const char * signal, int i) { }

  bool isA(const char * name) const { return true; }

  virtual QMetaObject * metaObject() const { return 0; }
  
};

class QSenderObject : public QObject
{
 public:
  void setSender(QObject * s) { } 
};


#endif
