#include "qpainter.h"
#include "fl_draw.H"

void QPainter::drawText(int x, int y, const QString & str, int len) 
{
  __SetBrushColor();
  if(len == -1) {
    fl_draw(str,ADJUSTX(x),ADJUSTY(y));
  } else {
    QString tmp(str);
    fl_draw(tmp.substr(0,len).c_str(),ADJUSTX(x),ADJUSTY(y));
  }
}
  


void QPainter::qDrawShadePanel( int x, int y, int w, int h,
				const QColorGroup & cg, bool sunken,
				int lineWidth = 1, const QBrush *fill = 0 ) 
{
 
  if(!sunken) {
    fl_color(cg.light().red(),
	     cg.light().green(),
	     cg.light().blue());
  } else {
    fl_color(cg.dark().red(),
	     cg.dark().green(),
	     cg.dark().blue());
  }

  for(int i=0; i<lineWidth; i++) {
    fl_line(ADJUSTX(x)+i,ADJUSTY(y)+i,ADJUSTX(x)+w-i,ADJUSTY(y)+i);
    fl_line(ADJUSTX(x)+i,ADJUSTY(y)+i,ADJUSTX(x)+i,ADJUSTY(y)+h-i);
    
  }

  if(sunken) {
    fl_color(cg.light().red(),
	     cg.light().green(),
	     cg.light().blue());
  } else {
    fl_color(cg.dark().red(),
	     cg.dark().green(),
	     cg.dark().blue());
  }

  for(int i=0; i<lineWidth; i++) {
    fl_line(ADJUSTX(x)+i,ADJUSTY(y)-i+h,ADJUSTX(x)+w-i,ADJUSTY(y)-i+h);
    fl_line(ADJUSTX(x)+w-i,ADJUSTY(y)+h-i,ADJUSTX(x)+w-i,ADJUSTY(y)+i);
  }

}
